/*
 * $Id: brdimpl.h,v 1.28 Broadcom SDK $
 *
 * $Copyright: Copyright 2015 Broadcom Corporation.
 * This program is the proprietary software of Broadcom Corporation
 * and/or its licensors, and may only be used, duplicated, modified
 * or distributed pursuant to the terms and conditions of a separate,
 * written license agreement executed between you and Broadcom
 * (an "Authorized License").  Except as set forth in an Authorized
 * License, Broadcom grants no license (express or implied), right
 * to use, or waiver of any kind with respect to the Software, and
 * Broadcom expressly reserves all rights in and to the Software
 * and all intellectual property rights therein.  IF YOU HAVE
 * NO AUTHORIZED LICENSE, THEN YOU HAVE NO RIGHT TO USE THIS SOFTWARE
 * IN ANY WAY, AND SHOULD IMMEDIATELY NOTIFY BROADCOM AND DISCONTINUE
 * ALL USE OF THE SOFTWARE.  
 *  
 * Except as expressly set forth in the Authorized License,
 *  
 * 1.     This program, including its structure, sequence and organization,
 * constitutes the valuable trade secrets of Broadcom, and you shall use
 * all reasonable efforts to protect the confidentiality thereof,
 * and to use this information only in connection with your use of
 * Broadcom integrated circuit products.
 *  
 * 2.     TO THE MAXIMUM EXTENT PERMITTED BY LAW, THE SOFTWARE IS
 * PROVIDED "AS IS" AND WITH ALL FAULTS AND BROADCOM MAKES NO PROMISES,
 * REPRESENTATIONS OR WARRANTIES, EITHER EXPRESS, IMPLIED, STATUTORY,
 * OR OTHERWISE, WITH RESPECT TO THE SOFTWARE.  BROADCOM SPECIFICALLY
 * DISCLAIMS ANY AND ALL IMPLIED WARRANTIES OF TITLE, MERCHANTABILITY,
 * NONINFRINGEMENT, FITNESS FOR A PARTICULAR PURPOSE, LACK OF VIRUSES,
 * ACCURACY OR COMPLETENESS, QUIET ENJOYMENT, QUIET POSSESSION OR
 * CORRESPONDENCE TO DESCRIPTION. YOU ASSUME THE ENTIRE RISK ARISING
 * OUT OF USE OR PERFORMANCE OF THE SOFTWARE.
 * 
 * 3.     TO THE MAXIMUM EXTENT PERMITTED BY LAW, IN NO EVENT SHALL
 * BROADCOM OR ITS LICENSORS BE LIABLE FOR (i) CONSEQUENTIAL,
 * INCIDENTAL, SPECIAL, INDIRECT, OR EXEMPLARY DAMAGES WHATSOEVER
 * ARISING OUT OF OR IN ANY WAY RELATING TO YOUR USE OF OR INABILITY
 * TO USE THE SOFTWARE EVEN IF BROADCOM HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES; OR (ii) ANY AMOUNT IN EXCESS OF
 * THE AMOUNT ACTUALLY PAID FOR THE SOFTWARE ITSELF OR USD 1.00,
 * WHICHEVER IS GREATER. THESE LIMITATIONS SHALL APPLY NOTWITHSTANDING
 * ANY FAILURE OF ESSENTIAL PURPOSE OF ANY LIMITED REMEDY.$
 *
 */

#ifndef _BRDIMPL_H_
#define _BRDIMPL_H_

#include "soc/soc.h"

/*
 * Typical board function implementation (most boards would fit)
 */
#include "brdimpl/rxtx.h"
#include "brdimpl/vlan.h"
#include "brdimpl/port.h"

typedef enum {
  CD_STATE_IDLE = 0,
  CD_STATE_FIRST_REPONSE, 
  CD_STATE_START, 
  CD_STATE_WAIT_LNKUP_1SEC, 
  CD_STATE_WAIT_LNKUP_2SEC, 
  CD_STATE_WAIT_LNKUP_3SEC, 
  CD_STATE_WAIT_LNKUP_4SEC, 
} CD_STATE;

typedef struct cable_cookie {
    uint16 uport;
    int done;
    CD_STATE phase;
    port_cable_diag_t cd;
}cable_cookie_t;

#ifdef CFG_RESET_BUTTON_INCLUDED
void brdimpl_reset_button_detect(void *param) REENTRANT;
#endif /* CFG_RESET_BUTTON_INCLUDED */

#ifdef CFG_LED_BUTTON_INCLUDED
void brdimpl_led_button_detect(void *param) REENTRANT;
#endif /* CFG_LED_BUTTON_INCLUDED */
void brdimpl_temp_detect(void *param) REENTRANT;
BOOL brdimpl_led_button_get(void) REENTRANT;
void brdimpl_led_button_set(void) REENTRANT;
#endif /* _BRDIMPL_H_ */
