/*
 * $Id: config_umweb.h,v 1.20.2.2 Broadcom SDK $
 *
 * $Copyright: Copyright 2015 Broadcom Corporation.
 * This program is the proprietary software of Broadcom Corporation
 * and/or its licensors, and may only be used, duplicated, modified
 * or distributed pursuant to the terms and conditions of a separate,
 * written license agreement executed between you and Broadcom
 * (an "Authorized License").  Except as set forth in an Authorized
 * License, Broadcom grants no license (express or implied), right
 * to use, or waiver of any kind with respect to the Software, and
 * Broadcom expressly reserves all rights in and to the Software
 * and all intellectual property rights therein.  IF YOU HAVE
 * NO AUTHORIZED LICENSE, THEN YOU HAVE NO RIGHT TO USE THIS SOFTWARE
 * IN ANY WAY, AND SHOULD IMMEDIATELY NOTIFY BROADCOM AND DISCONTINUE
 * ALL USE OF THE SOFTWARE.  
 *  
 * Except as expressly set forth in the Authorized License,
 *  
 * 1.     This program, including its structure, sequence and organization,
 * constitutes the valuable trade secrets of Broadcom, and you shall use
 * all reasonable efforts to protect the confidentiality thereof,
 * and to use this information only in connection with your use of
 * Broadcom integrated circuit products.
 *  
 * 2.     TO THE MAXIMUM EXTENT PERMITTED BY LAW, THE SOFTWARE IS
 * PROVIDED "AS IS" AND WITH ALL FAULTS AND BROADCOM MAKES NO PROMISES,
 * REPRESENTATIONS OR WARRANTIES, EITHER EXPRESS, IMPLIED, STATUTORY,
 * OR OTHERWISE, WITH RESPECT TO THE SOFTWARE.  BROADCOM SPECIFICALLY
 * DISCLAIMS ANY AND ALL IMPLIED WARRANTIES OF TITLE, MERCHANTABILITY,
 * NONINFRINGEMENT, FITNESS FOR A PARTICULAR PURPOSE, LACK OF VIRUSES,
 * ACCURACY OR COMPLETENESS, QUIET ENJOYMENT, QUIET POSSESSION OR
 * CORRESPONDENCE TO DESCRIPTION. YOU ASSUME THE ENTIRE RISK ARISING
 * OUT OF USE OR PERFORMANCE OF THE SOFTWARE.
 * 
 * 3.     TO THE MAXIMUM EXTENT PERMITTED BY LAW, IN NO EVENT SHALL
 * BROADCOM OR ITS LICENSORS BE LIABLE FOR (i) CONSEQUENTIAL,
 * INCIDENTAL, SPECIAL, INDIRECT, OR EXEMPLARY DAMAGES WHATSOEVER
 * ARISING OUT OF OR IN ANY WAY RELATING TO YOUR USE OF OR INABILITY
 * TO USE THE SOFTWARE EVEN IF BROADCOM HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES; OR (ii) ANY AMOUNT IN EXCESS OF
 * THE AMOUNT ACTUALLY PAID FOR THE SOFTWARE ITSELF OR USD 1.00,
 * WHICHEVER IS GREATER. THESE LIMITATIONS SHALL APPLY NOTWITHSTANDING
 * ANY FAILURE OF ESSENTIAL PURPOSE OF ANY LIMITED REMEDY.$
 *
 */

#ifndef _CONFIG_H_
#define _CONFIG_H_

/* Chip type */
#define CFG_XGS_CHIP                        (1)
#define CFG_ROBO_CHIP                       (!CFG_XGS_CHIP)

/* System endian */
#define CFG_LITTLE_ENDIAN                   (1)

#define CONFIG_GREYHOUND_ROMCODE            (0)

#define CONFIG_GREYHOUND_EMULATION          (0)


/* Enable console output */
#define CFG_CONSOLE_ENABLED                 (1)

/* Enable debug output */
#define CFG_DEBUGGING_ENABLED               (0)

/* Enable assertion */
#define CFG_ASSERTION_ENABLED               (0)

/* Enhanced power saving */
#define CFG_ENHANCED_POWER_SAVING           (0)

/* Enable packet RX/TX support */
#define CFG_RXTX_SUPPORT_ENABLED            (1)

/* Enable SAL LIB_support */
#define CFG_SAL_LIB_SUPPORT_ENABLED         (1)

/* CLI support */
#define CFG_CLI_ENABLED                     (1 && CFG_CONSOLE_ENABLED)

/* CLI prompt */
#define CFG_CLI_PROMPT                      "CMD> "

/* CLI system commands support */
#define CFG_CLI_SYSTEM_CMD_ENABLED          (1)

/* CLI switch commands support */
#define CFG_CLI_SWITCH_CMD_ENABLED          (1)

/* CLI power commands support */
#define CFG_CLI_POWER_CMD_ENABLED           (0)

/* CLI RX commands support */
#define CFG_CLI_RX_CMD_ENABLED              (1)

/* CLI TX commands support */
#define CFG_CLI_TX_CMD_ENABLED              (1)

/* CLI RX monitor */
#define CFG_CLI_RX_MON_PRIORITY             (1)

/* uIP main control RX priority */
#define CFG_UIP_RX_PRIORITY                 (10)

/* CLI TX packet configurations */
#define CFG_CLI_TX_MAX_PKTCFGS              (8)

/* UART baudrate */
#if CONFIG_GREYHOUND_EMULATION
#define CFG_UART_BAUDRATE                 (300)
#else
#define CFG_UART_BAUDRATE                (9600)
#endif

#define CFG_PCIE_SERDES_POWERDOWN_ENABLED   (1)

/* Max background tasks */
#define CFG_MAX_BACKGROUND_TASKS            (8)

/* Enable timer callback mechanism */
#define CFG_TIMER_CALLBACK_SUPPORT          (1)

/* Max registered timer (callback) */
#define CFG_MAX_REGISTERED_TIMERS           (16)

/* Enable linkchange callback mechanism */
#define CFG_LINKCHANGE_CALLBACK_SUPPORT     (1)

/* Max registered link change callback */
#define CFG_MAX_REGISTERED_LINKCHANGE       (16)

/* Interval for checking link change (in us) */
#define CFG_LINKCHANGE_CHECK_INTERVAL       (600000UL)

/* Max registered RX callback functions */
#define CFG_MAX_REGISTERED_RX_CBKS          (16)

/* Whether RX uses interrupt for receiving notification */
#define CFG_RX_USE_INTERRUPT                (0)

/* Packet length (excluding CRC) */
#define MIN_PACKET_LENGTH                   (60)
#define MAX_PACKET_LENGTH                   (1514)

/* FP */
#define ENTRIES_PER_SLICE                   (256)


/* Critical region protection with antoher processor*/
#define CFG_SOC_SEMAPHORE_INCLUDED

/* chip type */
#define CFG_SWITCH_XGS_NEW_SBUS_FORMAT_INCLUDED

/* Stoarge related */
#define CFG_FLASH_SUPPORT_ENABLED           (1)
#define CFG_CLI_FLASH_CMD_ENABLED           (1)

/* A factory data management engine */
#define CFG_FACTORY_CONFIG_INCLUDED

/* A binary storage management engine, named serializer */
#define CFG_PERSISTENCE_SUPPORT_ENABLED     (1)

#define CFG_SWITCH_VLAN_INCLUDED
#define CFG_MAX_NUM_OF_QVLANS        (16)
/* IP above layer related  setting*/
#define CFG_UIP_STACK_ENABLED               (1)
#define MAX_IP_TOTAL_LENGTH                 (1500)
#define CFG_UIP_IPV6_ENABLED                (1 && CFG_UIP_STACK_ENABLED)
#define CFG_NET_LINKCHANGE_NOTIFY_INCLUDED
#define CFG_NET_MAX_LINKCHANGE_HANDLER      (8)
/* HTTP server is enabled */
#define CFG_HTTPD_ENABLED                   (1)

/* DHCP client */
#define CFG_DHCPC_INCLUDED

/* To add a serial number into factory */
#define CFG_PRODUCT_REGISTRATION_INCLUDED

/* To enable login web pages and related mechanism*/
#define CFG_SYSTEM_PASSWORD_INCLUDED

/*To set the timeout of access control */
#define CFG_ADMINP_LOGIN_TIMEOUT            (5 * 60 * 1000)

/* Zero Configuration Networking */
/* Auto config of IPv4 Link-Local Addresses */
#define CFG_ZEROCONF_AUTOIP_INCLUDED    

/* Multicast DNS and DNS-SD (Bonjour) */
#define CFG_ZEROCONF_MDNS_INCLUDED      

#ifdef CFG_ZEROCONF_MDNS_INCLUDED
/* End with dot symbol */
#define CFG_MDNS_DEFAULT_HTTP_INSTANCE "TEG-7080ES."
/* TXT record information */
#define CFG_MDNS_MODEL_NAME "TEG-7080ES"
#define CFG_MDNS_MODEL_DESC "8-Port 10G EdgeSmart Switch"

#define CFG_MDNS_CUSTOMER "Trendnet"

#endif /* CFG_ZEROCONF_MDNS_INCLUDED */


/*
  *  CFG_NVRAM_SUPPORT_INCLUDED
  *      undefined : exclude the NVRAM defined advance command line engine
  *      defined: include the NVRAM storage
  */

/* #define CFG_NVRAM_SUPPORT_INCLUDED */




/****************************************************************************
 *
 * Features defined below can be selectively add or removed before building the image
 *
 ****************************************************************************/

/*
  *  CFG_VENDOR_CONFIG_SUPPORT_INCLUDED
  *      undefined : exclude VENDOR CONFIG related code
  *      defined: will include the NVRAM ,some XCMD utils and VENDOR CONFIG code
  */
        
#define CFG_VENDOR_CONFIG_SUPPORT_INCLUDED


/*
  *  CFG_XCOMMAND_INCLUDED
  *      undefined : exclude the XML defined advance command line engine
  *      defined: include the XML defined advance command line engine
  */
#define CFG_XCOMMAND_INCLUDED

/*
  *  CFG_SWITCH_DOS_INCLUDED
  *      undefined : exclude DOS control feature
  *      defined: include DOS control feature
  */  
#define CFG_SWITCH_DOS_INCLUDED

/*
  *  CFG_SWITCH_LAG_INCLUDED
  *      undefined : exclude LAG feature 
  *      defined: include LAG feature
  */  
#define CFG_SWITCH_LAG_INCLUDED

/*
  *  CFG_SWITCH_JUMBO_FRAME_INCLUDED
  *      undefined : exclude JUMBO FRAME feature 
  *      defined: include JUMBO FRAME feature
  */  
#define CFG_SWITCH_JUMBO_FRAME_INCLUDED

/*
  *  CFG_SWITCH_LOOPDETECT_INCLUDED
  *      undefined : exclude loop-detect feature 
  *      defined: include loop-detect feature 
  */  
#define CFG_SWITCH_LOOPDETECT_INCLUDED

/*
  *  CFG_SWITCH_MIRROR_INCLUDED
  *      undefined : exclude mirror feature 
  *      defined: include mirror feature 
  */
#define CFG_SWITCH_MIRROR_INCLUDED

/*
  *  CFG_SWITCH_QOS_INCLUDED
  *      undefined : exclude QoS feature 
  *      defined: include QoS feature
  */
#define CFG_SWITCH_QOS_INCLUDED

/*
  *  CFG_SWITCH_RATE_INCLUDED
  *      undefined : exclude rate feature 
  *      defined: include rate feature
  */
#define CFG_SWITCH_RATE_INCLUDED

/*
  *  CFG_SWITCH_SNAKETEST_INCLUDED
  *      undefined : exclude snaketest feature 
  *      defined: include snaketest feature
  */
#define CFG_SWITCH_SNAKETEST_INCLUDED

/*
  *  CFG_SWITCH_STAT_INCLUDED
  *      undefined : exclude statistic feature 
  *      defined: include statistic feature
  */
#define CFG_SWITCH_STAT_INCLUDED

/*
  *  CFG_SWITCH_MCAST_INCLUDED
  *      undefined : exclude MCAST feature 
  *      defined: include MCAST feature
  */
#define CFG_SWITCH_MCAST_INCLUDED

/*
  *  CFG_SWITCH_EEE_INCLUDED
  *      undefined : exclude EEE (Ethernet Energy Effieciency) feature
  *      defined: include EEE (Ethernet Energy Effieciency) feature
  */
#define CFG_SWITCH_EEE_INCLUDED

/*
  *  CFG_SWITCH_PVLAN_INCLUDED
  *      undefined : exclude port-based VLAN feature
  *      defined: exclude port-based VLAN feature
  */
//#define CFG_SWITCH_PVLAN_INCLUDED

/*
  *  CFG_SWITCH_L2_ADDR_INCLUDED
  *      undefined : exclude L2_ADDR/FDB feature 
  *      defined: include L2_ADDR/FDB feature 
  */
#define CFG_SWITCH_L2_ADDR_INCLUDED /*midi,fdb*/

/*
  *  CFG_SWITCH_FLOW_CTR_INCLUDED
  *      undefined : exclude flow control feature 
  *      defined: include flow control feature 
  */
#define CFG_SWITCH_FLOW_CTR_INCLUDED /*Jiecheng*/

/*
  *  CFG_SWITCH_ACL_INCLUDED
  *      undefined : exclude acl feature 
  *      defined: include acl feature 
  */
#define CFG_SWITCH_ACL_INCLUDED /* Haowei */

/*
  *  CFG_HW_CABLE_DIAG_INCLUDED
  *      undefined : exclude cable dialognostic feature 
  *      defined: include cable dialognostic feature 
  */
#define CFG_HW_CABLE_DIAG_INCLUDED

/*
  *  CFG_DUAL_IMAGE_INCLUDED
  *      undefined : exclude dual image feature
  *      defined: include dual image feature
  */
#define CFG_DUAL_IMAGE_INCLUDED

/*
  *  CFG_RESET_BUTTON_INCLUDED
  *      undefined : exclude reset button feature
  *      defined: include reset button feature
  */
#define CFG_RESET_BUTTON_INCLUDED

/*
  *  CFG_LED_BUTTON_INCLUDED
  *      undefined : exclude LED button feature
  *      defined: include LED button feature
  */
#define CFG_LED_BUTTON_INCLUDED

/*
  *  CFG_LED_MICROCODE_INCLUDED
  *      undefined : exclude serial LED feature
  *      defined as 1 : includee serial LED feature and use "direct serial out" 
  *      defined as 2 : includee serial LED feature and use "internal serial-to-parallel to chip ballout" 
  */
#define CFG_LED_MICROCODE_INCLUDED   (2)

/*
  *  CFG_CONFIG_OPTION : 
  * BCM53402: Option 1
  *                             1: 8x1G/2.5G/5G/10G
  * BCM53406: Option 1-4
  *                             1: 12x1G/2.5G/5G/10G + 12x1G/2.5G
  *                             2: 4xXAUI + 8x1G/2.5G/5G/10G
  *                             3: 4xXAUI + 4x1G/2.5G/5G/10G
  *                             4: 15x1G/2.5G/5G/10G + 9x1G
  * BCM53456: Option 1-3
  *                             1: 4xQSGMII + 8x1G/2.5G + 4x1G/2.5G/5G/10G
  *                             2: 4xQSGMII + 8x1G/2.5G + 2x10G + 2x13G
  *                             3: 2xQSGMII + 16x1G/2.5G + 4x1G/2.5G/5G/10G
  * BCM53424: Option 1-3
  *                             1: 4xQSGMII + 8x1G + 4x1G/2.5G/5G/10G
  *                             2: 4xQSGMII + 8x1G + 2x10G + 2x13G
  *                             3: 2xQSGMII + 16x1G + 4x1G/2.5G/5G/10G
  */
#define CFG_CONFIG_OPTION  (1)

/*
  *  CFG_CONFIG_1G_PORT_AN : default AN mode on ports with fiber mode and max speed is 1G 
  *      defined as 0 : disable AN
  *      defined as 1 : CL73
  *      defined as 2 : CL37
  */
#define CFG_CONFIG_1G_PORT_AN  (2)

/*
  *  CFG_CONFIG_10G_PORT_AN : default AN mode on ports with fiber mode and max speed is 10G 
  *      defined as 0 : disable AN
  *      defined as 1 : CL73
  */
#define CFG_CONFIG_10G_PORT_AN  (1)

/*
  *  CFG_TSCE_INTERFACE : TSCE_INTERFACE_SGMII/TSCE_INTERFACE_FIBER
  */
#define CFG_TSCE_INTERFACE   (TSCE_INTERFACE_FIBER)

 /* model Name define
  *  CFG_MODEL_NAME
  *      defined as 0 : Normal version SW-XX1208T
  *      defined as 1 : EDIMAX  XGS-5008
  *      defined as 2 : ELECOM  EHB-UT2A08F (dumb switch, base on SW-UX1208T)
  *      defined as 3 : SW-UX1208T(dumb switch)
  *      defined as 4 : Trendnet TEG-7080ES 
  */
#define CFG_MODEL_NAME  (4)

 /* LED Type define
  *  CFG_LED_TYPE
  *      defined as 0 : all black 
  *      defined as 1 : all green
  *      defined as 2 : all amber 
  *      defined as 3 : left link ,right act 
  *      defined as 4 : left link/act 
  *      defined as 5 : right diag/loop
  *      defined as 6 : five speed
  */
#define CFG_LED_TYPE  (6)

#ifdef CFG_SWITCH_ACL_INCLUDED
/* Slice 0 for L3/L4 fields look up */
#define L3L4_FP_SLICE_IDX           0
#define ZONE_DEF_RULE_BASE          0
#define SG_ZONE_DEF_KEY(i)          (L3L4_FP_SLICE_IDX * ENTRIES_PER_SLICE + ZONE_DEF_RULE_BASE + i)
#define ZONEDEFENSE_L3_RULE_IDX     0
#define ZONEDEFENSE_L3_RULE_NUM     8
#define ZONEDEFENSE_L2_RULE_IDX     9
#define ZONEDEFENSE_L2_RULE_NUM     16
#define SG_DHCP_PORT68_RULE_IDX     16
#define SG_DHCP_PORT68_KEY          (L3L4_FP_SLICE_IDX * ENTRIES_PER_SLICE + SG_DHCP_PORT68_RULE_IDX)
#define SG_RATE_IGR_IDX             (L3L4_FP_SLICE_IDX * ENTRIES_PER_SLICE + SG_DHCP_PORT68_RULE_IDX + 1)
#define SG_HTTP_RULE_IDX            9
#define SG_HTTP_KEY                 (L3L4_FP_SLICE_IDX * ENTRIES_PER_SLICE + SG_HTTP_RULE_IDX)
#define SG_ICMP_RULE_IDX            10
#define SG_ICMP_KEY                 (L3L4_FP_SLICE_IDX * ENTRIES_PER_SLICE + SG_ICMP_RULE_IDX)
#define SG_IGMP_RULE_IDX            11
#define SG_IGMP_KEY                 (L3L4_FP_SLICE_IDX * ENTRIES_PER_SLICE + SG_IGMP_RULE_IDX)
#define SG_SNMP_RULE_IDX            12
#define SG_SNMP_KEY                 (L3L4_FP_SLICE_IDX * ENTRIES_PER_SLICE + SG_SNMP_RULE_IDX)
#define SG_SYSLOG_RULE_IDX          13
#define SG_SYSLOG_KEY               (L3L4_FP_SLICE_IDX * ENTRIES_PER_SLICE + SG_SYSLOG_RULE_IDX)
#define SG_TFTP_RULE_IDX            14
#define SG_TFTP_KEY                 (L3L4_FP_SLICE_IDX * ENTRIES_PER_SLICE + SG_TFTP_RULE_IDX)
#define SG_TFTP_DATA_RULE_IDX       15
#define SG_TFTP_DATA_KEY            (L3L4_FP_SLICE_IDX * ENTRIES_PER_SLICE + SG_TFTP_DATA_RULE_IDX)

#define IGMP_FP_RULE_IDX            61
#define IGMP_FP_KEY                 (L3L4_FP_SLICE_IDX * ENTRIES_PER_SLICE + IGMP_FP_RULE_IDX)
#define RESERVED_MCIP_FP_RULE_IDX   62
#define RESERVED_MCIP_FP_KEY        (L3L4_FP_SLICE_IDX * ENTRIES_PER_SLICE + RESERVED_MCIP_FP_RULE_IDX)

/* Slice 1 for L2 fields look up */
#define L2_FP_SLICE_IDX             1
#define LBD_KEY(x)                  (L2_FP_SLICE_IDX * ENTRIES_PER_SLICE + x)
#define LBD_REDIR_KEY(x)            (L2_FP_SLICE_IDX * ENTRIES_PER_SLICE + x + BCM5340X_LPORT_MAX + 1)
#define SG_BPDU_RULE_IDX            40
#define SG_BPDU_KEY                 (L2_FP_SLICE_IDX * ENTRIES_PER_SLICE + SG_BPDU_RULE_IDX)
#define SG_LACP_RULE_IDX            41
#define SG_LACP_KEY                 (L2_FP_SLICE_IDX * ENTRIES_PER_SLICE + SG_LACP_RULE_IDX)
#define SG_LLDP_RULE_IDX            42
#define SG_LLDP_KEY                 (L2_FP_SLICE_IDX * ENTRIES_PER_SLICE + SG_LLDP_RULE_IDX)
#define SG_ARP_RULE_IDX             43
#define SG_ARP_KEY                  (L2_FP_SLICE_IDX * ENTRIES_PER_SLICE + SG_ARP_RULE_IDX)
#define SG_SYSMAC_RULE_IDX          44
#define SG_SYSMAC_KEY               (L2_FP_SLICE_IDX * ENTRIES_PER_SLICE + SG_SYSMAC_RULE_IDX)
#define SG_BROADCAST_RULE_IDX       45
#define SG_BROADCAST_KEY            (L2_FP_SLICE_IDX * ENTRIES_PER_SLICE + SG_BROADCAST_RULE_IDX)
#define SG_ERPS_RULE_IDX            46
#define SG_ERPS_KEY                 (L2_FP_SLICE_IDX * ENTRIES_PER_SLICE + SG_ERPS_RULE_IDX)
#define SG_LBD_RULE_IDX             47
#define SG_LBD_KEY                  (L2_FP_SLICE_IDX * ENTRIES_PER_SLICE + SG_LBD_RULE_IDX)
#define SG_PAE_RULE_IDX             48
#define SG_PAE_KEY                  (L2_FP_SLICE_IDX * ENTRIES_PER_SLICE + SG_PAE_RULE_IDX)
#define SG_8021AG_RULE_IDX          49
#define SG_8021AG_KEY               (L2_FP_SLICE_IDX * ENTRIES_PER_SLICE + SG_8021AG_RULE_IDX)
#define SG_PAE_RESERVED_RULE_IDX        50
#define SG_PAE_RESERVED_KEY             (L2_FP_SLICE_IDX * ENTRIES_PER_SLICE + SG_PAE_RESERVED_RULE_IDX)
#define SG_8021D_RESERVED_RULE_IDX      51
#define SG_8021D_RESERVED_KEY           (L2_FP_SLICE_IDX * ENTRIES_PER_SLICE + SG_8021D_RESERVED_RULE_IDX)
#define SG_GMRP_GVRP_RESERVED_RULE_IDX  52
#define SG_GMRP_GVRP_RESERVED_KEY       (L2_FP_SLICE_IDX * ENTRIES_PER_SLICE + SG_GMRP_GVRP_RESERVED_RULE_IDX)
/* This TRAP_SYSMAC_FP_RULE_IDX cannot over 61 since MAX entry index is 63 */
/* This TRAP_SYSMAC_FP_RULE_IDX   is for IPV4 trap to CPU */
/* This TRAP_SYSMAC_FP_RULE_IDX+1 is for IPV6 trap to CPU */
/* This TRAP_SYSMAC_FP_RULE_IDX+2 is for uIP  trap to CPU */

#define DROP_DOS_FP_RULE_IDX     60
#define DROP_DOS_KEY             (L2_FP_SLICE_IDX * ENTRIES_PER_SLICE + DROP_DOS_FP_RULE_IDX)
#define TRAP_SYSMAC_FP_RULE_IDX     61
#define TRAP_SYSMAC_KEY             (L2_FP_SLICE_IDX * ENTRIES_PER_SLICE + TRAP_SYSMAC_FP_RULE_IDX)
#define SLICE1_TEST_FP_RULE_IDX     50
#define SLICE1_TEST_KEY             (L2_FP_SLICE_IDX * ENTRIES_PER_SLICE + SLICE1_TEST_FP_RULE_IDX)

/* Slice 2 for port-based look up */
#define PORT_BASE1_FP_SLICE_IDX     2
#define QOS_FP_RULE_IDX             64

#define UDF_FP_SLICE_IDX            2
#define UDF_FP_RULE_IDX             0
#define UDF_FP_RULE_KEY             (UDF_FP_SLICE_IDX * ENTRIES_PER_SLICE + UDF_FP_RULE_IDX)
#define DDP_FP_RULE_IDX             60
#define DDP_FP_RULE_KEY             (UDF_FP_SLICE_IDX * ENTRIES_PER_SLICE + DDP_FP_RULE_IDX)


/* Slice 3 for L2 fields look up */
#define L2_FP_SLICE3_IDX            3
#define VV_NEW_PRI_RULE_BASE        0
#define VV_NEW_PRI_KEY(i)           (L2_FP_SLICE3_IDX * ENTRIES_PER_SLICE + VV_NEW_PRI_RULE_BASE + i)
#define SV_NEW_PRI_RULE_BASE        8
#define SV_NEW_PRI_KEY(i)           (L2_FP_SLICE3_IDX * ENTRIES_PER_SLICE + SV_NEW_PRI_RULE_BASE + i)
#define VV_UP2CPU_RULE_BASE         16
#define VV_UP2CPU_KEY(i)            (L2_FP_SLICE3_IDX * ENTRIES_PER_SLICE + VV_UP2CPU_RULE_BASE + i)
#define SV_UP2CPU_RULE_BASE         36
#define SV_UP2CPU_KEY(i)            (L2_FP_SLICE3_IDX * ENTRIES_PER_SLICE + SV_UP2CPU_RULE_BASE + i)
#define IPV6_MC_FLOODING_RULE_IDX   63
#define IPV6_MC_FLOODING_KEY        (L2_FP_SLICE3_IDX * ENTRIES_PER_SLICE + IPV6_MC_FLOODING_RULE_IDX)

#define FP_SLICE4_IDX               4
#define FP_SLICE5_IDX               5
#define FP_SLICE6_IDX               6
#define FP_SLICE7_IDX               7
#define SLICE4_TEST_FP_RULE_IDX     50
#define SLICE5_TEST_FP_RULE_IDX     50
#define SLICE6_TEST_FP_RULE_IDX     50
#define SLICE7_TEST_FP_RULE_IDX     50
#define SLICE4_TEST_KEY             (FP_SLICE4_IDX * ENTRIES_PER_SLICE + SLICE4_TEST_FP_RULE_IDX)
#define SLICE5_TEST_KEY             (FP_SLICE5_IDX * ENTRIES_PER_SLICE + SLICE5_TEST_FP_RULE_IDX)
#define SLICE6_TEST_KEY             (FP_SLICE6_IDX * ENTRIES_PER_SLICE + SLICE6_TEST_FP_RULE_IDX)
#define SLICE7_TEST_KEY             (FP_SLICE7_IDX * ENTRIES_PER_SLICE + SLICE7_TEST_FP_RULE_IDX)

#define SG_SYSMAC_RATE              1024
#define SG_BROADCAST_RATE           32
#define SG_BPDU_RATE                16
#define SG_ARP_RATE                 8
#define SG_DHCP_RATE                8

#endif /* CFG_SWITCH_ACL_INCLUDED */

#endif /* _CONFIG_H_ */
